﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace WpfApp1
{

    public class LineChangeMonitor : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            return values?[0];
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class LineCollection : List<List<Point>>
    {

    }

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var p = new Point(-105.517363, 44.287229);
            var rect = new Rect(p, new Size(0.01, 0.01));

            LinePoints = new LineCollection { new List<Point> {
                         rect.TopRight,
                         rect.BottomLeft,
                         rect.TopLeft,
                         rect.BottomRight
                     }};

            WorldRect = rect;
        }
      
        #region WorldRect Dependency Property

        public static readonly DependencyProperty WorldRectProperty =
            DependencyProperty.Register("WorldRect",
                                        typeof(Rect),
                                        typeof(MainWindow),
                                        new PropertyMetadata(default(Rect)));

        public Rect WorldRect
        {
            get
            {
                Rect res = default(Rect);

                if (CheckAccess() != false)
                {
                    res = (Rect) GetValue(WorldRectProperty);
                }
                else
                {
                    Dispatcher.Invoke(() => res = (Rect) GetValue(WorldRectProperty));
                }

                return res;
            }
            set
            {
                if (CheckAccess() != false)
                {
                    SetValue(WorldRectProperty, value);
                }
                else
                {
                    Dispatcher.Invoke(() => SetValue(WorldRectProperty, value));
                }
            }
        }

        #endregion

        #region ListChangeCount Dependency Property

        public static readonly DependencyProperty ListChangeCountProperty =
            DependencyProperty.Register("ListChangeCount",
                                        typeof(ulong),
                                        typeof(MainWindow),
                                        new PropertyMetadata(default(ulong)));

        public ulong ListChangeCount
        {
            get
            {
                ulong res = default(ulong);

                if (CheckAccess() != false)
                {
                    res = (ulong) GetValue(ListChangeCountProperty);
                }
                else
                {
                    Dispatcher.Invoke(() => res = (ulong) GetValue(ListChangeCountProperty));
                }

                return res;
            }
            set
            {
                if (CheckAccess() != false)
                {
                    SetValue(ListChangeCountProperty, value);
                }
                else
                {
                    Dispatcher.Invoke(() => SetValue(ListChangeCountProperty, value));
                }
            }
        }

        #endregion


  

        //#region Lines Dependency Property

        //public static readonly DependencyProperty LinesProperty =
        //    DependencyProperty.Register("Lines",
        //                                typeof(ObservableCollection<Line>),
        //                                typeof(MainWindow),
        //                                new PropertyMetadata(default(ObservableCollection<Line>)));

        //public ObservableCollection<Line> Lines
        //{
        //    get
        //    {
        //        ObservableCollection<Line> res = default(ObservableCollection<Line>);

        //        if (CheckAccess() != false)
        //        {
        //            res = (ObservableCollection<Line>) GetValue(LinesProperty);
        //        }
        //        else
        //        {
        //            Dispatcher.Invoke(() => res = (ObservableCollection<Line>) GetValue(LinesProperty));
        //        }

        //        return res;
        //    }
        //    set
        //    {
        //        if (CheckAccess() != false)
        //        {
        //            SetValue(LinesProperty, value);
        //        }
        //        else
        //        {
        //            Dispatcher.Invoke(() => SetValue(LinesProperty, value));
        //        }
        //    }
        //}

        //#endregion

        #region
        public const string LinePointsPropertyName = "LinePoints";
        public static DependencyProperty LinePointsProperty = DependencyProperty.Register(
            LinePointsPropertyName, typeof(LineCollection), typeof(MainWindow), null);

        /// <summary>
        /// Gets or sets whether the OptionsPanel can be movable within its parent control's boundaries.  
        /// </summary>
        public LineCollection LinePoints
        {
            get
            {
                return (LineCollection)GetValue(LinePointsProperty);
            }
            set
            {
                SetValue(LinePointsProperty, value);
               
            }
        }
        #endregion
        
        private void XamGeographicMap_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var p = new Point(-105.517363, 44.287229);
            var rect = new Rect(p, new Size(0.01, 0.01));

            //var pl = new PointList
            //         {
            //             rect.TopLeft,
            //             rect.TopRight,
            //             rect.BottomRight,
            //             rect.BottomLeft
            //         };

            //var l = new Line
            //        {
            //            Points = pl
            //        };

            //Lines.Clear();
            //Lines.Add(l);

            var newLine = new List<Point> {
                         rect.TopLeft,
                         rect.BottomRight,
                     };

            // bug in our control only if using ObservableCollection to store points that define lines
            LinePoints.Clear();
            LinePoints.Add(newLine);

            ListChangeCount++;

            // workaround
            //LinePoints = new LineCollection { new List<Point> {
            //             rect.TopLeft,
            //             rect.BottomRight,
            //             //rect.TopRight,
            //             //rect.BottomLeft
            //         }};


            // potential workaround, 
            // but not suitable for situations where lines collection is bound to readonly collection that can't 
            // be set to null

            //
            //var lc = Lines;
            //Lines = null;

            //lc.Clear();
            //lc.Add(l);

            //Lines = lc;
            //
        }
    }
}
